{#-#####################################################################
 # Template for /etc/rc.conf.d/netif
 #======================================================================
 # Main template file
 ####################################################################-#}
{#-=====================================================================
 # Imports
 #===================================================================-#}
{%- import "inc/common.j2"   as common     with context -%}
{%- import "inc/ifconfig.j2" as ifconfig   with context -%}
{%- import "inc/rcvars.j2"   as rcvars     with context -%}

{#-=====================================================================
 # render
 # ---------------------------------------------------------------------
 #
 # Generates a single netif file with the configuration of all supplied
 # network interfaces.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interfaces (fr.pep06.schemas.network.interface[])
 #      A list of network interface definitions to process.
 #===================================================================-#}
{%- macro render(interfaces) -%}

  {%- set line_buffer = [] -%}

  {#--------------------------------------------------------------------
   # Common variables
   #------------------------------------------------------------------#}

  {{ '# ' ~ ansible_managed ~ "\n\n" }}

  {#- Cloned interfaces -#}
  {%- set cloned_interfaces =
      rcvars.render_cloned_interfaces() -%}
  {%- if cloned_interfaces -%}
    {{ line_buffer.append(cloned_interfaces) }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Interface variables
   #------------------------------------------------------------------#}
  {%- for interface in interfaces -%}

    {#- Set interface creation arguments
     #
     #  We show this one first because create_args_x vars are processed
     #  **before** interface renaming.
    -#}
    {%- set create_args_var =
      rcvars.render_create_args_x(interface)-%}
    {%- if create_args_var -%}
      {{ line_buffer.append(create_args_var) }}
    {%- endif -%}

    {#- Set interface name and description -#}
    {%- set rename_var =
      rcvars.render_ifconfig_x_name(interface) -%}
    {%- set descr_var =
      rcvars.render_ifconfig_x_descr(interface) -%}
    {%- if rename_var -%}
      {{ line_buffer.append(rename_var) }}
    {%- endif -%}
    {%- if descr_var -%}
      {{ line_buffer.append(descr_var) }}
    {%- endif -%}

    {#- Set ifconfig inet (link + IPv4) options -#}
    {%- set inet_var =
      rcvars.render_ifconfig_x(interface) -%}
    {%- if inet_var -%}
      {{ line_buffer.append(inet_var) }}
    {%- endif -%}

    {#- Set ifconfig inet (IPv4) aliases -#}
    {%- set inet_alias_vars =
      rcvars.render_ifconfig_x_aliases(interface) -%}
    {%- if inet_alias_vars -%}
      {{ line_buffer.append(inet_alias_vars) }}
    {%- endif -%}

    {#- Set ifconfig inet6 (IPv6) options -#}
    {%- set inet6_var =
      rcvars.render_ifconfig_x_inet6(interface) -%}
    {%- if inet6_var -%}
      {{ line_buffer.append(inet6_var) }}
    {%- endif -%}

  {%- endfor -%}

  {#- Dump line buffer -#}
  {{ line_buffer | join() }}

{%- endmacro -%}

{{ render(my_network_interfaces) }}